/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.document.impl;

import java.io.InputStream;
import java.io.StringWriter;

import org.exoplatform.container.xml.InitParams;
import org.pdfbox.pdmodel.PDDocument;
import org.pdfbox.util.PDFTextStripper;

/**
 * Created by The eXo Platform SARL
 * Author : Phung Hai Nam
 *          phunghainam@gmail.com
 * Oct 19, 2005
 */
public class PDFDocumentReader extends BaseDocumentReader {
  
  public PDFDocumentReader(InitParams params) {
    
  }
  
  public String getMimeTypes() {    return "application/pdf" ; }
  
  public String getContentAsText(InputStream is) throws Exception {
    PDDocument pdDocument = PDDocument.load(is); 
    StringWriter sw = new StringWriter();
    try {
      PDFTextStripper stripper = new PDFTextStripper();                
      stripper.setStartPage( 1 );
      stripper.setEndPage(Integer.MAX_VALUE );
      stripper.writeText(pdDocument, sw);
    } finally {
      if(pdDocument != null) pdDocument.close();
    } 
    return sw.toString();
  }
  
}
