/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.organization;

import java.util.Collection;

/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Oct 13, 2005
 */
public interface MembershipHandler {
  public Membership createMembershipInstance();
  public void createMembership(Membership m, boolean broadcast) throws Exception;
  public void linkMembership(User user, Group group, MembershipType m, boolean broadcast) throws Exception ;
  //public void saveMembership(Membership m, boolean broadcast) throws Exception ;
  public Membership removeMembership(String id, boolean broadcast) throws Exception ;
  public Membership findMembership(String id) throws Exception ;
  public Membership findMembershipByUserGroupAndType(String userName, String groupId, String type) throws Exception ;
  public Collection findMembershipsByUserAndGroup(String userName, String groupId) throws Exception ;
  public Collection findMembershipsByUser(String userName) throws Exception ;
  public Collection findMembershipsByGroup(Group group) throws Exception ;
  
  public  void addMembershipEventListener(MembershipEventListener listener) ;
}
