/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.organization;

import org.exoplatform.commons.utils.PageList;

/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Oct 13, 2005
 */
public interface UserHandler {
  public User createUserInstance() ;
  public void createUser(User user, boolean broadcast) throws Exception ;
  public void saveUser(User user, boolean broadcast) throws Exception ;
  public User removeUser(String userName, boolean broadcast) throws Exception ;
  public User findUserByName(String userName) throws Exception ;
  public PageList findUsersByGroup(String groupId) throws Exception ; 
  public PageList getUserPageList(int pageSize) throws Exception ;
  public PageList findUsers(Query query) throws Exception ;
  public boolean authenticate(String username, String password) throws Exception ;
  
  public  void addUserEventListener(UserEventListener listener) ;
}
