/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.core.component.model;

import java.io.IOException;
import java.util.ResourceBundle;

import javax.faces.context.ResponseWriter;
import org.exoplatform.faces.core.component.UIGrid;
import org.exoplatform.commons.utils.ExpressionUtil ;
/**
 * Wed, Dec 22, 2003 @ 23:14 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: LabelCell.java,v 1.5 2004/06/30 19:52:01 tuan08 Exp $
 */

public class LabelCell extends Cell {
  private String for_ ;
  private String accesskey_ ;

  public LabelCell(String value) {
    super(value) ;
  }

  public LabelCell setLabel(String value) {
    value_ = value ;
    return this ;
  }

  public LabelCell setFor(String value) {
    for_ = value ;
    return this ;
  }

  public LabelCell setAccesskey(String value) {
    accesskey_ = value ;;
    return this ;
  }

  public void render(ResponseWriter w, ResourceBundle res,UIGrid uiGrid, String cellTag) throws IOException { 
    w.write('<'); w.write(cellTag) ;
    if(attributes_ != null) {
      int size = attributes_.size() ;
      for(int i = 0; i < size ; i++) {
        Cell.Attribute attr = (Cell.Attribute) attributes_.get(i) ;
        w.write(' '); w.write(attr.name_); w.write("=\""); w.write(attr.value_); w.write('\"') ;
      }
    }
    w.write('>') ;
    w.write("<label") ;
    if (for_ != null) {
      w.write(" for='");  w.write(for_); w.write("'") ;
    }
    if (accesskey_ != null) {
      w.write(" accesskey='"); w.write(accesskey_); w.write("'") ;
    }
    w.write(">") ;
    w.write(ExpressionUtil.getExpressionValue(res,value_)) ;
    w.write("</label></"); w.write(cellTag); w.write(">") ;
  }
}