/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.faces.listener.share;

import javax.faces.component.UIComponent;

import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.faces.component.*;

/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 16, 2004
 * @version $Id: EditPropertiesActionListener.java,v 1.2 2004/09/27 20:44:59 tuan08 Exp $
 */
public class EditPropertiesActionListener extends ExoActionListener  {
  public void execute(ExoActionEvent event) throws Exception {
    UIPortalComponent uiComponent = (UIPortalComponent) event.getSource() ;
    UIPortal uiPortal = (UIPortal)uiComponent.getAncestorOfType(UIPortal.class) ;
    if(uiComponent instanceof UIPage) {
      UIPageForm uiPageForm = 
        (UIPageForm)PortalComponentCache.findPortalComponent(UIPageForm.class) ;
      UIComponent returnComponent = uiPortal.findUIBody().getBodyComponent() ;
      uiPageForm.setEditingPage(returnComponent, (UIPage) uiComponent) ;
      uiPortal.setBodyComponent(uiPageForm) ;
    } else if(uiComponent instanceof UIContainer) {
      UIContainerForm uiContainerForm = 
        (UIContainerForm)PortalComponentCache.findPortalComponent(UIContainerForm.class) ;
      UIComponent returnComponent = uiPortal.findUIBody().getBodyComponent() ;
      uiContainerForm.setEditingContainer(returnComponent, (UIContainer) uiComponent) ;
      uiPortal.setBodyComponent(uiContainerForm) ;
    } else if(uiComponent instanceof UIPortlet) {
      UIComponent returnComponent = uiPortal.findUIBody().getBodyComponent() ;
      UIPortletConfig uiPortletConfig = 
        (UIPortletConfig)PortalComponentCache.findPortalComponent(UIPortletConfig.class) ;
      uiPortletConfig.setEditingPortlet(returnComponent, (UIPortlet) uiComponent) ;
      uiPortal.setBodyComponent(uiPortletConfig) ;
    } else if(uiComponent instanceof UIPortal) {
      UIPortalForm uiPortalForm =(UIPortalForm)PortalComponentCache.findPortalComponent(UIPortalForm.class);
      uiPortalForm.setUIPortal(uiPortal) ;
      uiPortal.setBodyComponent(uiPortalForm) ;
    }
  }
}
