/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlet.faces;

import javax.faces.FactoryFinder;
import javax.faces.render.RenderKit;
import javax.faces.render.RenderKitFactory;

import org.exoplatform.faces.core.component.UIDateInput;
import org.exoplatform.faces.core.component.UIDateTimeInput;
import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.faces.core.component.UIForm;
import org.exoplatform.faces.core.component.UIPageListIterator;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.UITextArea;
import org.exoplatform.faces.core.component.UITimeInput;
import org.exoplatform.faces.core.component.UIToolbar;
import org.exoplatform.faces.core.component.UIUploadInput;
import org.exoplatform.faces.core.renderer.html.ChildrenRenderer;
import org.exoplatform.faces.core.renderer.html.DateInputRenderer;
import org.exoplatform.faces.core.renderer.html.DateTimeInputRenderer;
import org.exoplatform.faces.core.renderer.html.FileUploadRenderer;
import org.exoplatform.faces.core.renderer.html.FormRenderer;
import org.exoplatform.faces.core.renderer.html.GridRenderer;
import org.exoplatform.faces.core.renderer.html.GroovyRenderer;
import org.exoplatform.faces.core.renderer.html.ListNodesRenderer;
import org.exoplatform.faces.core.renderer.html.NodeTabbedPaneRenderer;
import org.exoplatform.faces.core.renderer.html.PageListIteratorRenderer;
import org.exoplatform.faces.core.renderer.html.PyramidTabBarRenderer;
import org.exoplatform.faces.core.renderer.html.SimpleFormButtonRenderer;
import org.exoplatform.faces.core.renderer.html.SimpleFormRenderer;
import org.exoplatform.faces.core.renderer.html.SimpleFormVelocityRenderer;
import org.exoplatform.faces.core.renderer.html.SimpleMultipartFormRenderer;
import org.exoplatform.faces.core.renderer.html.SimpleTabRenderer;
import org.exoplatform.faces.core.renderer.html.StringInputRenderer;
import org.exoplatform.faces.core.renderer.html.TextAreaRenderer;
import org.exoplatform.faces.core.renderer.html.TimeInputRenderer;
import org.exoplatform.faces.core.renderer.html.ToolbarRenderer;
import org.exoplatform.faces.core.renderer.html.UploadInputRenderer;
import org.exoplatform.faces.core.renderer.html.VelocityNodeMenuRenderer;
import org.exoplatform.faces.core.renderer.html.VelocityRenderer;
import org.exoplatform.portlet.faces.renderer.PortletPreferencesRenderer;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 4, 2004
 * @version $Id: XHTMLRendererConfiguration.java,v 1.8 2004/10/25 03:53:06 tuan08 Exp $
 */
public class XHTMLRendererConfiguration {
  static public void confiure() throws Exception {
    RenderKitFactory rfactory = 
      (RenderKitFactory) FactoryFinder.getFactory( FactoryFinder.RENDER_KIT_FACTORY );
    RenderKit rkit = 
      rfactory.getRenderKit(null, RenderKitFactory.HTML_BASIC_RENDER_KIT);
    if(rkit.getRenderer(UIExoComponent.COMPONENT_FAMILY, "VelocityRenderer") == null) {
      rkit.addRenderer(UIExoComponent.COMPONENT_FAMILY, "VelocityRenderer", new VelocityRenderer());
    }
    if(rkit.getRenderer(UIExoComponent.COMPONENT_FAMILY, "VelocityNodeMenuRenderer") == null) {
      rkit.addRenderer(UIExoComponent.COMPONENT_FAMILY, "VelocityNodeMenuRenderer", new VelocityNodeMenuRenderer());
    }
    if(rkit.getRenderer(UIExoComponent.COMPONENT_FAMILY, "GroovyRenderer") == null) {
      rkit.addRenderer(UIExoComponent.COMPONENT_FAMILY, "GroovyRenderer", new GroovyRenderer());
    }
    if(rkit.getRenderer(UIExoComponent.COMPONENT_FAMILY, "SimpleFormVelocityRenderer") == null) {
      rkit.addRenderer(UIExoComponent.COMPONENT_FAMILY, "SimpleFormVelocityRenderer", new SimpleFormVelocityRenderer());
    }
    if(rkit.getRenderer(UIStringInput.COMPONENT_FAMILY, "StringInputRenderer") == null) {
      rkit.addRenderer(UIStringInput.COMPONENT_FAMILY, "StringInputRenderer", new StringInputRenderer());
    }
    if(rkit.getRenderer(UIDateInput.COMPONENT_FAMILY, "DateInputRenderer") == null) {
      rkit.addRenderer(UIDateInput.COMPONENT_FAMILY, "DateInputRenderer", new DateInputRenderer());
    }
    if(rkit.getRenderer(UITimeInput.COMPONENT_FAMILY, "TimeInputRenderer") == null) {
      rkit.addRenderer(UITimeInput.COMPONENT_FAMILY, "TimeInputRenderer", new TimeInputRenderer());
    }
    if(rkit.getRenderer(UIDateTimeInput.COMPONENT_FAMILY, "DateTimeInputRenderer") == null) {
      rkit.addRenderer(UIDateTimeInput.COMPONENT_FAMILY, "DateTimeInputRenderer", new DateTimeInputRenderer());
    }
    if(rkit.getRenderer(UITextArea.COMPONENT_FAMILY, "TextAreaRenderer") == null) {
      rkit.addRenderer(UITextArea.COMPONENT_FAMILY, "TextAreaRenderer", new TextAreaRenderer());
    }
    if(rkit.getRenderer(UIUploadInput.COMPONENT_FAMILY, "UploadInputRenderer") == null) {
      rkit.addRenderer(UIUploadInput.COMPONENT_FAMILY, "UploadInputRenderer", new UploadInputRenderer());
    }        
    if(rkit.getRenderer(UIExoComponent.COMPONENT_FAMILY, "SimpleFormRenderer") == null) {
      rkit.addRenderer(UIExoComponent.COMPONENT_FAMILY, "SimpleFormRenderer", new SimpleFormRenderer());
    }
    if(rkit.getRenderer(UIExoComponent.COMPONENT_FAMILY, "SimpleMultipartFormRenderer") == null) {
      rkit.addRenderer(UIExoComponent.COMPONENT_FAMILY, "SimpleMultipartFormRenderer", new SimpleMultipartFormRenderer());
    }    
    if(rkit.getRenderer(UIExoComponent.COMPONENT_FAMILY, "SimpleFormButtonRenderer") == null) {
      rkit.addRenderer(UIExoComponent.COMPONENT_FAMILY,  "SimpleFormButtonRenderer", new SimpleFormButtonRenderer());
    }
    if(rkit.getRenderer(UIForm.COMPONENT_FAMILY, "FormRenderer") == null) {
      rkit.addRenderer(UIForm.COMPONENT_FAMILY,  "FormRenderer", new FormRenderer());
    }
    if(rkit.getRenderer(UIPageListIterator.COMPONENT_FAMILY, "PageListIteratorRenderer") == null) {
      rkit.addRenderer(UIPageListIterator.COMPONENT_FAMILY,  "PageListIteratorRenderer", new PageListIteratorRenderer());
    }    
    if(rkit.getRenderer(UIToolbar.COMPONENT_FAMILY, "ToolbarRenderer") == null) {
      rkit.addRenderer(UIToolbar.COMPONENT_FAMILY,  "ToolbarRenderer", new ToolbarRenderer());
    }    
    if(rkit.getRenderer(UIExoComponent.COMPONENT_FAMILY, "GridRenderer") == null) {
      rkit.addRenderer(UIExoComponent.COMPONENT_FAMILY, "GridRenderer", new GridRenderer());
    }
    if(rkit.getRenderer(UIExoComponent.COMPONENT_FAMILY, "ChildrenRenderer") == null) {
      rkit.addRenderer(UIExoComponent.COMPONENT_FAMILY, "ChildrenRenderer", new ChildrenRenderer());
    }
    if(rkit.getRenderer(UIExoComponent.COMPONENT_FAMILY, "TabbedPaneRenderer") == null) {
      rkit.addRenderer(UIExoComponent.COMPONENT_FAMILY, "TabbedPaneRenderer", new NodeTabbedPaneRenderer());
    }
    if(rkit.getRenderer(UIExoComponent.COMPONENT_FAMILY, "SimpleTabRenderer") == null) {
      rkit.addRenderer(UIExoComponent.COMPONENT_FAMILY, "SimpleTabRenderer", new SimpleTabRenderer());
    }
    if(rkit.getRenderer(UIExoComponent.COMPONENT_FAMILY, "PyramidTabBarRenderer") == null) {
      rkit.addRenderer(UIExoComponent.COMPONENT_FAMILY, "PyramidTabBarRenderer", new PyramidTabBarRenderer());
    }
    if(rkit.getRenderer(UIExoComponent.COMPONENT_FAMILY, "ListNodesRenderer") == null) {
      rkit.addRenderer(UIExoComponent.COMPONENT_FAMILY, "ListNodesRenderer", new ListNodesRenderer());
    }
    if(rkit.getRenderer(UIExoComponent.COMPONENT_FAMILY, "PortletPreferencesRenderer") == null) {
      rkit.addRenderer(UIExoComponent.COMPONENT_FAMILY, "PortletPreferencesRenderer", new PortletPreferencesRenderer());
    }
    if(rkit.getRenderer(UIExoComponent.COMPONENT_FAMILY, "FileUploadRenderer") == null) {
      rkit.addRenderer(UIExoComponent.COMPONENT_FAMILY, "FileUploadRenderer", new FileUploadRenderer());
    }  
  }
}
