/**
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */
package org.exoplatform.portlets.cache.component;

import java.util.Collection;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.cache.CacheService;
import org.exoplatform.services.cache.ExoCache;
/**
 * Created y the eXo platform team
 * User: Benjamin Mestrallet
 * Date: 22 juin 2004
 */
public class UIListCache  extends UIExoCommand  {
  final static public String CLEAR_ACTION = "clear" ;
  final static public String REFRESH_ACTION = "refresh" ;
  final static public String VIEW_ACTION = "view" ;
  private static Parameter[] CLEAR_PARAMS = {new Parameter(ACTION , CLEAR_ACTION) } ;
  private static Parameter[] VIEW_PARAMS = {new Parameter(ACTION , VIEW_ACTION) } ;

  CacheService cservice_ ;
  
  public UIListCache(CacheService cservice) throws Exception {
    setId("UIListCache") ;
    cservice_ = cservice ;
    setRendererType("VelocityRenderer") ;
    addActionListener(ClearActionListener.class, CLEAR_ACTION) ;
    addActionListener(ViewChartActionListener.class, VIEW_ACTION) ;    
  }

  public Parameter[] getClearParams() { return CLEAR_PARAMS ; }
  public Parameter[] getViewParams() { return VIEW_PARAMS ; }
  
  public Collection getAllCacheInstances() throws Exception {
    return cservice_.getAllCacheInstances() ;
  }

  static public class ViewChartActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
    	UIListCache uiListCache = (UIListCache) event.getComponent() ;
    	UICachesChart uiChart = (UICachesChart)uiListCache.getSibling(UICachesChart.class) ;
    	Collection cacheList = (Collection)uiListCache.getAllCacheInstances();
      System.out.println("\n\n\n\n\n\n UPDATE") ;
		  uiChart.updateDataSet(cacheList) ;
      uiListCache.setRenderedSibling(UICachesChart.class) ;
    }
  }
  
  static public class ClearActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UIListCache uiListCache = (UIListCache) event.getComponent() ;
      String name = event.getParameter(OBJECTID) ;
      ExoCache cache = uiListCache.cservice_.getCacheInstance(name) ;      
      cache.clearCache() ;
    }
  }  
}