/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.jmx.component;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.exoplatform.commons.utils.ExceptionUtil;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.RootContainer;
import org.exoplatform.services.chart.ChartService;

import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGImageEncoder;
/**
 * Created by The eXo Platform SARL        .
 * Sun, Dec 28, 2003 @ 14:57 
 * @author: Tuan Nguyen
 * @version: $Id: FileContentServlet.java,v 1.3 2004/06/23 03:19:01 tuan08 Exp $
 * @email: tuan08@yahoo.com
 */
public class ChartViewServlet extends HttpServlet {
	
	public void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    response.setHeader("Cache-Control", "private max-age=600, s-maxage=120");
		ServletOutputStream os = response.getOutputStream() ;
		try {
      response.setContentType("image/jpeg") ;
			String partInfo = request.getPathInfo() ;
      String portal = partInfo.substring(partInfo.indexOf("portal=") + 7 , partInfo.indexOf("&"));
      String chartId = partInfo.substring(partInfo.indexOf("chartId=") + 8 );
      PortalContainer pcontainer = 
				RootContainer.getInstance().getPortalContainer(portal) ;
			if(pcontainer == null){
				throw new Exception("Cannot find the portal container:  " + portal) ;
			}
			ChartService  service =
				(ChartService)  pcontainer.getComponentInstanceOfType(ChartService.class) ;
			PortalContainer.setInstance(pcontainer) ;
      if (chartId.equals("null")){
        String errorString = "Chart's data does not correct, please back to list cache and click [ view ] button again!" ;
        BufferedImage image = new BufferedImage(600,400 , BufferedImage.TYPE_INT_RGB);
        Graphics2D offscreen = (Graphics2D)image.getGraphics() ;
        offscreen.setColor(Color.lightGray);
        offscreen.fillRect(0, 0, 600, 400);
        offscreen.setColor(Color.black);
        offscreen.drawString(errorString, 70, 200);
        JPEGImageEncoder pp = JPEGCodec.createJPEGEncoder(os);
        pp.encode(image);        
      }else{
        BufferedImage image = service.getChartByID(chartId);
        JPEGImageEncoder pp = JPEGCodec.createJPEGEncoder(os);
        pp.encode(image);        
      }
		} catch (Exception ex) {
			ex.printStackTrace() ;	
			String s = ExceptionUtil.getStackTrace(ex, 20) ;
			os.println(s) ;
		} finally {
			PortalContainer.setInstance(null) ;
		}
	}
}
