/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.monitor.component;

import java.util.* ;

import org.exoplatform.faces.core.component.UIDateTimeInput;
import org.exoplatform.faces.core.component.UINode;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.model.SelectItem ;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;

/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UISearchForm.java,v 1.4 2004/09/29 17:44:51 benjmestrallet Exp $
 */
public class UIUserLogFilter extends UISimpleForm {
  static String  USER_NAME = "userName", LIMIT = "limit", DURATION_ORDER = "durationOrder", 
                 FROM_DATE_TIME = "fromDateTime", TO_DATE_TIME = "toDateTime", 
                 ACCESS_IP = "accessIp", PORTAL_NAME = "portalName", TIMESLOT_ORDER = "timeSlotOrder" ;

  public UIUserLogFilter() {
    super("filterForm", "post", null) ;
    setId("UIUserLogFilter");
    setClazz("UISimpleForm") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    GregorianCalendar calendar = new GregorianCalendar() ;
    calendar.set(GregorianCalendar.HOUR_OF_DAY, 0) ;
    calendar.set(GregorianCalendar.MINUTE, 0) ;
    calendar.set(GregorianCalendar.SECOND, 0) ;
    calendar.set(GregorianCalendar.MILLISECOND, 0) ;
    add(new UIDateTimeInput(FROM_DATE_TIME,calendar.getTime())) ;
    
    calendar.set(GregorianCalendar.HOUR_OF_DAY, 24) ;
    add(new UIDateTimeInput(TO_DATE_TIME,calendar.getTime())) ;
    
    add(new UIStringInput(USER_NAME, "")) ;
    add(new UIStringInput(PORTAL_NAME, "")) ;
    add(new UIStringInput(ACCESS_IP, "")) ;
    List<SelectItem> limitLog = new ArrayList<SelectItem>() ;
    limitLog.add(new SelectItem("No limited", "0")) ;
    limitLog.add(new SelectItem(" < 50 logs", "50")) ;
    limitLog.add(new SelectItem(" < 100 logs", "100")) ;
    limitLog.add(new SelectItem(" < 500 logs", "500")) ;
    limitLog.add(new SelectItem(" < 1.000 logs", "1000")) ;
    limitLog.add(new SelectItem(" < 5.000 logs", "5000")) ;
    limitLog.add(new SelectItem(" < 10.000 logs", "10000")) ;
    add(new UISelectBox(LIMIT, "0", limitLog)) ;
    
    List<SelectItem> durationOrder = new ArrayList<SelectItem>() ;
    durationOrder.add(new SelectItem("None", "")) ;
    durationOrder.add(new SelectItem("Desc", "Desc")) ;
    durationOrder.add(new SelectItem("Asc", "Asc")) ;
    add(new UISelectBox(DURATION_ORDER, "", durationOrder)) ;
    
    List<SelectItem> orderItems = new ArrayList<SelectItem>() ;
    orderItems.add(new SelectItem("None", "")) ;
    orderItems.add(new SelectItem("Desc", "Desc")) ;
    orderItems.add(new SelectItem("Asc", "Asc")) ;
    add(new UISelectBox(TIMESLOT_ORDER, "Desc", orderItems)) ;
    
    addActionListener(UpdateActionListener.class, UPDATE_ACTION) ;
  }
  
  public String getUpdateAction() { return UPDATE_ACTION ; }
  
  static public class UpdateActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception { 
		  UIUserLogFilter uiForm = (UIUserLogFilter) event.getSource() ;
      String userName = uiForm.getUIStringInput(USER_NAME).getValue() ;
      if(userName == null || userName.length() == 0) userName = "" ;
      String portalName = uiForm.getUIStringInput(PORTAL_NAME).getValue() ;
      if(portalName == null || portalName.length() == 0) portalName = "" ;
      String accessIp = uiForm.getUIStringInput(ACCESS_IP).getValue() ;
      if(accessIp == null || accessIp.length() == 0) accessIp = "" ;
      String timeSlotOrder = uiForm.getUISelectBox(TIMESLOT_ORDER).getValue() ;
      if(timeSlotOrder == null || timeSlotOrder.length() == 0) timeSlotOrder = "" ;
      long fromDateTime = uiForm.getUIDateTimeInput(FROM_DATE_TIME).getCalendar().getTimeInMillis() ;
      long toDateTime = uiForm.getUIDateTimeInput(TO_DATE_TIME).getCalendar().getTimeInMillis() ;
      //String limit  = uiForm.getUISelectBox(LIMIT).getValue() ;
      String durationOrder  = uiForm.getUISelectBox(DURATION_ORDER).getValue() ;
      if(durationOrder == null || durationOrder.length() == 0) durationOrder = "" ;
      String limit = "0" ;
      String maxmin = "" ;
      
      Object obj = uiForm.getParent() ;
      if (obj.getClass().equals(UIStatisticsUserActionLog.class)){
        UIStatisticsUserActionLog uiStatistics = (UIStatisticsUserActionLog) uiForm.getParent() ;
        uiStatistics.update(fromDateTime, toDateTime, limit, userName, portalName, maxmin, 
                            accessIp, timeSlotOrder, durationOrder) ;        
      }else {
        UINode uiMonitor  = (UINode)uiForm.getParent().getParent();
        UIStatisticsUserActionLog uiStatistics = 
          (UIStatisticsUserActionLog) uiMonitor.getChildComponentOfType(UIStatisticsUserActionLog.class) ;
        uiStatistics.update(fromDateTime, toDateTime, limit, userName, portalName, maxmin, 
                            accessIp, timeSlotOrder, durationOrder) ;      
        UIUserActivitiesLogChart uiMultiChart = 
          (UIUserActivitiesLogChart)uiStatistics.getSibling(UIUserActivitiesLogChart.class) ;
        uiStatistics.setRenderedSibling(UIUserActivitiesLogChart.class) ;
        Collection logChartList = uiStatistics.getChartData();
        uiMultiChart.updateUserLogDataSet(logChartList, uiStatistics.getChartStyle(), maxmin) ;
      }      
		}	
  }
}