/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portal.impl.converter.v11tov2;

import java.util.ArrayList;
import java.util.List;

import org.exoplatform.xml.object.XMLObject;
import org.exoplatform.services.portal.model.Container;
import org.exoplatform.services.portal.model.Portlet;
import org.exoplatform.services.portal.model.PortletPreferences;

/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Nov 21, 2005
 */
public class Converter extends BaseConverter {
  
  PortletConverter portletConverter;
  
  public Converter(){    
    portletConverter = new PortletConverter();    
  }
  
  public void convertPage( XMLObject xml) throws Exception {     
    this.convertPermission( xml, "editPermission") ;
    this.convertPermission( xml, "viewPermission") ;
  }
  
  public void convertContainer( XMLObject xml) throws Exception {    
    setField(xml, "decorator", "exo", "default"); 
    setField(xml, "decorator", "exo-body", "default"); 
    setField(xml, "decorator", "menu", "default");
    setField(xml, "renderer", "exo", "default"); 
    setField(xml, "renderer", "ContainerRowRenderer", null);  
  }
  
  public void convertPageNode( XMLObject xml) throws Exception {    
    this.convertPermission( xml, "editPermission") ;
    this.convertPermission( xml, "viewPermission") ; 
  }
  
  public void convertPortlet( XMLObject xml) throws Exception {       
     portletConverter.convert( xml); 
  }
  
  public void convertPortalConfig( XMLObject xml) throws Exception {   
    convertPermission( xml,"editPermission");
    convertPermission( xml,"viewPermission");
    setField(xml, "decorator", "*", "community"); 
    setField(xml, "renderer", "*", "default"); 
    xml.removeField("mobilePortalLayout");
  }  
  
  public void convertBody( XMLObject xml) throws Exception {  
    setField(xml, "id", "*", "body");
  }  
  
  public void pack( XMLObject xml) throws Exception {  
    portletConverter.pack( xml);
  }
  
}
