/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portal.test;

import java.io.File;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Comparator;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.services.backup.ImportExportService;
import org.exoplatform.services.database.HibernateService;
import org.exoplatform.services.organization.Group;
import org.exoplatform.services.organization.Membership;
import org.exoplatform.services.organization.MembershipType;
import org.exoplatform.services.organization.OrganizationService;
import org.exoplatform.services.organization.User;
import org.exoplatform.services.organization.UserProfile;
import org.exoplatform.services.portal.PortalConfigService;
import org.exoplatform.services.portal.impl.NodeNavigationData;
import org.exoplatform.services.portal.impl.PageData;
import org.exoplatform.services.portal.impl.PortalConfigData;
import org.exoplatform.services.portal.impl.PortalConfigServiceImpl;
import org.exoplatform.services.portal.model.Page;
import org.exoplatform.services.portal.model.PortalConfig;
import org.exoplatform.test.BasicTestCase;
import org.hibernate.Session;

/**
 * Created by The eXo Platform SARL
 * Author : Hoa  Pham
 *          hoapham@exoplatform.com,phamvuxuanhoa@yahoo.com
 * Nov 15, 2005
 */
public class TestImportExportService extends ImportExportServiceTestBase {  
  
    
  public TestImportExportService(String name) {
    super( name);
  }
  
  public void testExport() throws Exception {    
    if( !test) return;
    prepareUserData();
    
    /*---------get all group and membership relation with users before export-import--*/
    Collection<Group> groupBeforeOfU_1 = orgService_.getGroupHandler().findGroupsOfUser(uName_1) ;        
    Collection<Membership> memBeforeOfU_1 = orgService_.getMembershipHandler().findMembershipsByUser(uName_1) ;
    
    /*---------------Assgin user2 to group1 with mType1------*/
    orgService_.getMembershipHandler().linkMembership( user2 ,group1,mType1,true) ;
    /*---------------Assgin user2 to group1 with mType2------*/
    orgService_.getMembershipHandler().linkMembership(user2,group2,mType1,true) ;
    /*---------Get all group and membership relation with user2 before export-import--*/
    Collection<Group> groupBeforeOfU_2 = orgService_.getGroupHandler().findGroupsOfUser(uName_2) ;
    Collection<Membership> memBeforeOfU_2 = orgService_.getMembershipHandler().findMembershipsByUser(uName_2) ;
    
        /*---------------Assgin demo{default user} to group1 with mType1------*/
    orgService_.getMembershipHandler().linkMembership(defaultUser,group1,mType1,true) ;
    /*---------Get all group and membership relation with "demo" before export-import--*/
    Collection<Group> groupBeforeOfDefault = orgService_.getGroupHandler().findGroupsOfUser("demo") ;
    Collection<Membership> memBeforeOfDefault = orgService_.getMembershipHandler().findMembershipsByUser("demo") ;
    
    service_.exportUserData() ;
    
//    System.out.println("--------- Begin Export all user's data-----------") ;
//    /* --Expect result: found 3 ZipFile with name:user1.zip, user2.zip,demo.zip(default user)
//     * --------and in a file has 6 entries: Memberships.xml/User.xml/UserProfile.xml---
//    *  ---- navigation-config.xml/pages-config.xml/portal-config.xml(/portal)-----*/
//    String[] portalEntries = {"Meberships.xml", "User.xml","UserProfile","navigation-config.xml",
//        "pages-config.xml","portal-config.xml"} ;
//    String[] organizationEntries = {"Memberships.xml","User.xml","UserProfile.xml"} ;
//    ZipFile zfile = getZipUserData(uName_1) ;
//    assertTrue("Expect entrys are found in zipfile of user:"+uName_1,hasEntry(zfile,organizationEntries)) ;
//    assertTrue("Expect entrys are found in zipfile of user:"+uName_1,hasEntry(zfile,portalEntries)) ;
//    zfile = getZipUserData(uName_2) ;
//    assertTrue("Expect entrys are found in zipfile of user :"+uName_2,hasEntry(zfile,organizationEntries)) ;
//    assertTrue("Expect entrys are found in zipfile of user :"+uName_2,hasEntry(zfile,portalEntries)) ;
//    zfile = getZipUserData("demo") ;
//    assertTrue("Expect entrys are found in zipfile of user :demo",hasEntry(zfile,organizationEntries)) ;
//    assertTrue("Expect entrys are found in zipfile of user :demo",hasEntry(zfile,portalEntries)) ;
//    zfile.close() ;
//    System.out.println("--------- Success export all user's data-----------") ;
    
//    System.out.println("--------- Clean database before import-----------") ;
////    orgService_.getUserHandler().removeUser(uName_1,true) ;
////    orgService_.getUserHandler().removeUser(uName_2,true) ;
////    orgService_.getUserHandler().removeUser("demo",true) ;
//    System.out.println("--------- Clean database successfull-----------") ;
//        
//    System.out.println("--------- begin import all user's data-----------") ;
//    service_.importUserData() ;
//    /*--------------Expect all data of USER_1 before/after export/import are same-----*/
//    Collection<Group> groupAfterOfU_1 = orgService_.getGroupHandler().findGroupsOfUser(uName_1) ;      
//    assertCollection(groupBeforeOfU_1,groupAfterOfU_1,new GroupComparator()) ;
//    
//    Collection<Membership> memAfterOfU_1 = orgService_.getMembershipHandler().findMembershipsByUser(uName_1) ;
//    assertCollection(memBeforeOfU_1,memAfterOfU_1,new MembershipComparator()) ;
//    
//    /*---Expect all data of USER_2 before/after export/import are same-----*/
//    Collection<Group> groupAfterOfU_2 = orgService_.getGroupHandler().findGroupsOfUser(uName_2) ;
//    assertCollection(groupBeforeOfU_2,groupAfterOfU_2,new GroupComparator()) ;
//    
//    Collection<Membership> memAfterOfU_2 = orgService_.getMembershipHandler().findMembershipsByUser(uName_2) ;
//    assertCollection(memBeforeOfU_2,memAfterOfU_2, new MembershipComparator()) ;
//    
//    /*---Expect all data of DEFAULT USER(demo) before/after export/import are same-----*/
//    Collection<Group> groupAfterOfDefault = orgService_.getGroupHandler().findGroupsOfUser("demo") ;
//    assertCollection(groupBeforeOfDefault,groupAfterOfDefault,new GroupComparator()) ;
//    
//    Collection<Membership> memAfterOfDefault = orgService_.getMembershipHandler().findMembershipsByUser("demo") ;
//    assertCollection(memBeforeOfDefault,memAfterOfDefault,new MembershipComparator()) ;    
//    System.out.println("---------import all user's data successful -----------") ;    
  }
      
  public void testImport() throws Exception {   
//    test = false;
//    if( !test) return;
//    service_.setDirectory("D:\\test\\serviceV1\\");
//    service_.importUserData( "aaa") ; 
//    System.out.println(service_.getImportLogger().getTextSummary());
//   
//    prepareUserData() ;        
//    /*---------------Assgin user1 to group1 with mType1------*/
//    orgService_.getMembershipHandler().linkMembership(user1,group1,mType1,true) ;
//    /*---------------Assgin user1 to group1 with mType2------*/
//    orgService_.getMembershipHandler().linkMembership(user1,group1,mType2,true) ;
//    /*---------------Assgin user1 to group2 with mType2------*/
//    orgService_.getMembershipHandler().linkMembership(user1,group2,mType2,true) ;
//    /*--------- get all data relation with user before import/export------------*/
//    Collection<Membership> memBefore = orgService_.getMembershipHandler().findMembershipsByUser(uName_1) ;    
//    Collection<Group> gBefore = orgService_.getGroupHandler().findGroupsOfUser(uName_1) ;
//    
//    Session session = hservice_.openSession();    
//    PortalConfigData portalBefore = (PortalConfigData) session.get( PortalConfigData.class, uName_1) ;     
//    List l = 
//      session.createQuery( PortalConfigServiceImpl.queryPageDataByOwner).setString(0, uName_1).list();
//    
//    List pagesBefore = new ArrayList(l.size() + 5)  ;
//    for(int i = 0 ; i < l.size(); i++) {
//      PageData pageData = (PageData) l.get(i) ;
//      pagesBefore.add(pageData.getPage()) ;
//    }
//    NodeNavigationData navigationBefore = 
//      (NodeNavigationData) session.get(NodeNavigationData.class, uName_1) ;    
//    session.clear() ;
//    
//    System.out.println("--------- Begin Export single user's data-----------") ; 
//    /* --Expect result: found a ZipFile with name:user1.userName.zip
//     * --------and it's entries are: Memberships.xml/User.xml/UserProfile.xml (organization)
//     *  ---- navigation-config.xml/pages-config.xml/portal-config.xml(/portal)-----*/
//    String[] entryNames = {"Meberships.xml", "User.xml","UserProfile","navigation-config.xml",
//        "pages-config.xml","portal-config.xml"} ;
//    service_.exportUserData(uName_1) ;    
//    ZipFile zfile = getZipUserData(uName_1) ;    
//    assertTrue("Expect 'memberships.xml' entry is found", hasEntry(zfile,"Memberships.xml")) ;
//    assertTrue("Expect 'User.xml' entry is found", hasEntry(zfile,"User.xml")) ;
//    assertTrue("Expect 'UserProfile.xml' entry is found", hasEntry(zfile,"UserProfile.xml" )) ;
//    assertTrue("Expect  entries is found", hasEntry(zfile,entryNames )) ;
//    zfile.close() ;
//    System.out.println("---------Export User data successful-----------") ;
//    
//    System.out.println("---------Clean database before import-----------") ;
//    orgService_.getUserHandler().removeUser(uName_1,true) ;
//    System.out.println("---------Clean database successfull-----------") ;
//    
//    System.out.println("------- Begin Import User data  --------------") ;    
//    service_.importUserData(uName_1) ;
//    User u = orgService_.getUserHandler().findUserByName(uName_1) ;
//    assertTrue("Expect user has found:",u!=null) ;
//    assertTrue("Expect user's info is correct:",u.getFirstName().equalsIgnoreCase("default")) ;
//    /*-------------find User Profile and check it----------------*/
//    UserProfile profile = orgService_.getUserProfileHandler().findUserProfileByName(uName_1) ;
//    assertTrue("Expect user profile has found:", profile.getUserName().equalsIgnoreCase(uName_1)) ;
//    assertEquals("Expect profile's info is correct: user.gender is ","male", profile.getUserInfoMap().get("user.gender"));
//    /*------------get all data relate with user after export/import and compare---------
//     * ----------with data that get before import/export to make sure they are same-----*/
//    Collection<Group>  gAfter= orgService_.getGroupHandler().findGroupsOfUser(uName_1) ;    
//    assertCollection(gBefore,gAfter,new GroupComparator()) ;
//        
//    Collection<Membership> memAfter = orgService_.getMembershipHandler().findMembershipsByUser(uName_1) ;
//    assertCollection(memBefore,memAfter, new MembershipComparator()) ;
//    
//    session = hservice_.openSession();    
//    PortalConfigData portalAfter = (PortalConfigData) session.get( PortalConfigData.class, uName_1) ;    
//    l = 
//      session.createQuery( PortalConfigServiceImpl.queryPageDataByOwner).setString(0, uName_1).list();
//    
//    List pagesAfter = new ArrayList(l.size() + 5)  ;
//    for(int i = 0 ; i < l.size(); i++) {
//      PageData pageData = (PageData) l.get(i) ;
//      pagesAfter.add(pageData.getPage()) ;
//    }
//    NodeNavigationData navigationAfter = 
//      (NodeNavigationData) session.get(NodeNavigationData.class, uName_1) ;    
//    
//    session.clear() ;    
//    assertObject(portalBefore,portalAfter,new PortalConfigDataComparator()) ;
//    //assertCollection(pagesBefore,pagesAfter,new PageConfigDataComparator()) ;
//    assertObject(navigationBefore,navigationAfter,new NavigationConfigDataComparator()) ;
//    System.out.println("----------Import single user data succesful -----------------") ;        
    
   }
  
  public void testExportImportV1ToV2() throws Exception {
   /*---------------Clean database before import V1.0.1 data----------*/
//    orgService_.getGroupHandler().removeGroup(group1,true) ;
//    orgService_.getGroupHandler().removeGroup(group2,true) ;
//    orgService_.getGroupHandler().removeGroup(defaultGroup,true) ;
//    orgService_.getMembershipTypeHandler().removeMembershipType(mType_1,true);
//    orgService_.getMembershipTypeHandler().removeMembershipType(mType_2,true) ;
//    orgService_.getMembershipTypeHandler().removeMembershipType(defaultType.getName(),true) ;
//    orgService_.getUserHandler().removeUser(uName_1,true)  ;
//    orgService_.getUserHandler().removeUser(uName_2,true) ;
//    orgService_.getUserHandler().removeUser(defaultName,true) ;
    /*----------------Clean database succesfull--------------------*/
    /*---------Import data of version 1.0.1 ------------*/
//    service_.setDirectory("/home/exo/backup/") ;    
//    service_.importUserData() ;
//    createUser("phamvuxuanhoa") ;
//    service_.setDirectory("/home/exo/v1/") ;
//    service_.exportUserData() ;
  } 
  
//public void testTransformServiceData() throws Exception {
//service_.transformServiceData() ;
//
//service_.transformUserData() ;
//}
}
